#include <iostream>

using namespace std;

#define LL long long
const int DIM=3;
LL m;

LL mul(LL a, LL b)
{   LL ans = 0;
    while(b)
    { if (b&1) ans = (ans + a) % m;
      a = 2 * a % m;
      b >>= 1;
    }
    return ans;
}

struct matr
{  
  LL el[DIM][DIM];
};
   
matr operator* (matr a, matr b)
{ matr c;
  for(int i=0; i<DIM; i++)
    for(int j=0; j<DIM; j++)
      { c.el[i][j] = 0;
        for(int k = 0; k<DIM; k++)
          c.el[i][j] = (c.el[i][j] +  mul(a.el[i][k],b.el[k][j]))% m;
      }
  return c;
}    

matr operator^(matr a, LL p)
{   matr ans = {1,0,0,
                0,1,0,
                0,0,1};
    while(p)
    { if (p&1) ans = ans*a;
      a = a*a;
      p >>= 1;
    }
    return ans;
}

int main()
{ matr a1 = {2,1,1,
             1,0,0,
             0,1,0};
  LL n;
  cin >> n >> m;
  if (n == 1) 
    { cout << 2 % m << endl;
      return 0;
    }
  if (n == 2) 
    { cout << 5 % m << endl;
      return 0;
    }
  if (n == 3) 
    { cout << 13 % m << endl;
      return 0;
    }
  matr x = a1^(n-3);
  cout << (13*x.el[0][0] + 5*x.el[0][1] + 2*x.el[0][2]) % m << endl;
  
  return 0;
}     
